var A = A || {};

/*--------------------------------------------------------------------------
  User Interface Methods
/*------------------------------------------------------------------------*/

A.UserInterface = {

  tabs: function () {

    jQuery('.tabs').each(function() {

      var activeClass = 'active',
        $tabs = jQuery('> ul li', this),
        $content = jQuery('.tab', this);

      $tabs.click(function() {
        $tabs.removeClass(activeClass);
        jQuery(this).addClass(activeClass);
        $content.removeClass(activeClass);
        $content.eq(jQuery(this).index()).addClass(activeClass);
        return false;
      });
    });
  },

  togglers: function () {

    jQuery('.toggle').each(function() {

      var $this = jQuery(this),
        $h4 = $this.children('h4'),
        $inner = $this.find('.toggle-inner'),
        isOpen = true,
        toggle = function() {
          isOpen = !isOpen;
          $inner.slideToggle('fast');
          $this[0].className = ((isOpen) ? 'open' : 'close') + ' toggle';
        };

      $h4.click(function(){ toggle(); return false; });
      if (!$this.hasClass('open')) toggle();
    });
  },

  sfolioBox: function() { // single portfolio lightbox

    if (!jQuery('ol.sfolio').length) return; // there is no ol.sfolio

    jQuery('ol.sfolio').on('click', 'li[data-zoom]', function() {
      var
        $body = jQuery('body'),
        $this = jQuery(this),
        d = $this.data(),
        src = d.zoom,
        $box = jQuery('<div class="lbox"><img src="'+src+'" alt="Image Title"><a href="#close">click to close</a></div>'); 

      jQuery('#main').append($box);
      $body.css({'overflow':'hidden'}); // hide scroller

      $box.one('click', function(){
        $body.css({'overflow':''}); // return scroller
        $box.remove();
      });
    });
  },

  contactForm: function() { // contact form client logic

    if (!jQuery('#contact').length) return;

    var
      errClass = 'err',
      $form = jQuery('#contact'),
      $msg = $form.find('textarea[name="msg"]'),
      msgDef = $msg.val(),
      $name = $form.find('input[name="name"]'),
      nameDef = $name.val(),
      $mail = $form.find('input[name="mail"]'),
      mailDef = $mail.val(),
      $send = $form.find('input[type="submit"]'),
      $submitAlt = jQuery('<a/>', { href: "#", text: $send.val() });

    // prepare
    $msg.attr('rows', 1).elastic().blur();
    $send.replaceWith($submitAlt);

    // emulating placeholders
    var placeholder = function($obj,dflt) {
      $obj
        .val(dflt)
        .focus(function(){ if ($obj.val() == dflt) $obj.val(''); $obj.removeClass(errClass); })
        .blur(function(){ if (!$obj.val()) $obj.val(dflt); });
    };
    placeholder($name, nameDef);
    placeholder($mail, mailDef);
    placeholder($msg, msgDef);

    // click event
    $submitAlt.click(function(ev){
      ev.preventDefault();

      var
        error = false,
        noText = function(c,dflt){ if (c.jquery) c=c.val(); return !(jQuery.trim(c).length && c!=dflt) },
        noMail = function(c) { if (c.jquery) c=c.val(); return !(c.match(/[a-zA-Z0-9_\.\-]+\@([a-zA-Z0-9\-]+\.)+[a-zA-Z0-9]{2,4}/)); };

      if (noText($msg,msgDef)) { $msg.addClass(errClass); error = true; }
      else $msg.removeClass(errClass);

      if (noText($name,nameDef)) { $name.addClass(errClass); error = true; }
      else $name.removeClass(errClass);

      if (noText($mail,mailDef) || noMail($mail)) { $mail.addClass(errClass); error = true; }
      else $mail.removeClass(errClass);
      
      if (error) return;
      
      $submitAlt.remove();
      jQuery.post($form.attr('action'), $form.serialize(), function (resp) {
          // resp = $(resp).find('#email-response').html();
          if (resp) $form.fadeOut(function () {
              $form.replaceWith(resp).fadeIn();
          });
      });

    });

  },

  autoLoad: function () {

    this.tabs();
    this.togglers();
    this.sfolioBox();
    this.contactForm();
  }
};

/*--------------------------------------------------------------------------
  Run 3rd-party jQuery Plugins
/*------------------------------------------------------------------------*/

A.JQueryPlugins = {

  autoLoad: function () {
    
    jQuery('a[href^="#"]').smoothScroll('ease-in');
  }
};

/*--------------------------------------------------------------------------
  Init jQuery & A Object
/*------------------------------------------------------------------------*/

; (function(){jQuery.noConflict();jQuery(document).ready(function(){for(var p in A)A.hasOwnProperty(p)&&A[p]&&A[p].autoLoad&&A[p].autoLoad()})})(jQuery);

/*--------------------------------------------------------------------------
  Packed 3rd-party jQuery Plugins
/*------------------------------------------------------------------------*/

// Custom easing
; jQuery.easing.jswing=jQuery.easing.swing;jQuery.extend(jQuery.easing,{def:'easeOut',swing:function(x,t,b,c,d){return jQuery.easing[jQuery.easing.def](x,t,b,c,d)},easeIn:function(x,t,b,c,d){return(!t)?b:c*Math.pow(2,10*(t/d-1))+b},easeOut:function(x,t,b,c,d){return(t==d)?b+c:c*(-Math.pow(2,-10*t/d)+1)+b},easeInOut:function(x,t,b,c,d){if(!t)return b;if(t==d)return b+c;if((t/=d/2)<1)return c/2*Math.pow(2,10*(t-1))+b;return c/2*(-Math.pow(2,-10*--t)+2)+b}});
// Elastic by Jan Jarfalk unwrongest.com MIT License http://www.opensource.org/licenses/mit-license.php
; (function($){jQuery.fn.extend({elastic:function(){var g=['paddingTop','paddingRight','paddingBottom','paddingLeft','fontSize','lineHeight','fontFamily','width','fontWeight','border-top-width','border-right-width','border-bottom-width','border-left-width','borderTopStyle','borderTopColor','borderRightStyle','borderRightColor','borderBottomStyle','borderBottomColor','borderLeftStyle','borderLeftColor'];return this.each(function(){if(this.type!=='textarea'){return false}var f=jQuery(this),$twin=jQuery('<div />').css({'position':'absolute','display':'none','word-wrap':'break-word','white-space':'pre-wrap'}),lineHeight=parseInt(f.css('line-height'),10)||parseInt(f.css('font-size'),'10'),minheight=parseInt(f.css('height'),10)||lineHeight*3,maxheight=parseInt(f.css('max-height'),10)||Number.MAX_VALUE,goalheight=0;if(maxheight<0){maxheight=Number.MAX_VALUE}$twin.appendTo(f.parent());var i=g.length;while(i--){$twin.css(g[i].toString(),f.css(g[i].toString()))}function setTwinWidth(){var a=Math.floor(parseInt(f.width(),10));if($twin.width()!==a){$twin.css({'width':a+'px'});update(true)}}function setHeightAndOverflow(a,b){var c=Math.floor(parseInt(a,10));if(f.height()!==c){f.css({'height':c+'px','overflow':b})}}function update(a){var b=f.val().replace(/&/g,'&amp;').replace(/ {2}/g,'&nbsp;').replace(/<|>/g,'&gt;').replace(/\n/g,'<br />');var c=$twin.html().replace(/<br>/ig,'<br />');if(a||b+'&nbsp;'!==c){$twin.html(b+'&nbsp;');if(Math.abs($twin.height()+lineHeight-f.height())>3){var d=$twin.height()+lineHeight;if(d>=maxheight){setHeightAndOverflow(maxheight,'auto')}else if(d<=minheight){setHeightAndOverflow(minheight,'hidden')}else{setHeightAndOverflow(d,'hidden')}}}}f.css({'overflow':'hidden'});f.bind('keyup change cut paste',function(){update()});$(window).bind('resize',setTwinWidth);f.bind('resize',setTwinWidth);f.bind('update',update);f.bind('blur',function(){if($twin.height()<maxheight){if($twin.height()>minheight){f.height($twin.height())}else{f.height(minheight)}}});f.bind('input paste',function(e){setTimeout(update,250)});update()})}})})(jQuery);
// Smooth Scroll by Karl Swedberg https://github.com/kswedberg/jquery-smooth-scroll MIT and GPL licenses
; (function(a){function f(a){return a.replace(/(:|\.)/g,"\\$1")}var b="1.4.6",c={exclude:[],excludeWithin:[],offset:0,direction:"top",scrollElement:null,scrollTarget:null,beforeScroll:function(){},afterScroll:function(){},easing:"swing",speed:400,autoCoefficent:2},d=function(b){var c=[],d=!1,e=b.dir&&b.dir=="left"?"scrollLeft":"scrollTop";return this.each(function(){if(this==document||this==window)return;var b=a(this);b[e]()>0?c.push(this):(b[e](1),d=b[e]()>0,d&&c.push(this),b[e](0))}),c.length||this.each(function(a){this.nodeName==="BODY"&&(c=[this])}),b.el==="first"&&c.length>1&&(c=[c[0]]),c},e="ontouchend"in document;a.fn.extend({scrollable:function(a){var b=d.call(this,{dir:a});return this.pushStack(b)},firstScrollable:function(a){var b=d.call(this,{el:"first",dir:a});return this.pushStack(b)},smoothScroll:function(b){b=b||{};var c=a.extend({},a.fn.smoothScroll.defaults,b),d=a.smoothScroll.filterPath(location.pathname);return this.unbind("click.smoothscroll").bind("click.smoothscroll",function(b){var e=this,g=a(this),h=c.exclude,i=c.excludeWithin,j=0,k=0,l=!0,m={},n=location.hostname===e.hostname||!e.hostname,o=c.scrollTarget||(a.smoothScroll.filterPath(e.pathname)||d)===d,p=f(e.hash);if(!c.scrollTarget&&(!n||!o||!p))l=!1;else{while(l&&j<h.length)g.is(f(h[j++]))&&(l=!1);while(l&&k<i.length)g.closest(i[k++]).length&&(l=!1)}l&&(b.preventDefault(),a.extend(m,c,{scrollTarget:c.scrollTarget||p,link:e}),a.smoothScroll(m))}),this}}),a.smoothScroll=function(b,c){var d,e,f,g,h=0,i="offset",j="scrollTop",k={},l={},m=[];typeof b=="number"?(d=a.fn.smoothScroll.defaults,f=b):(d=a.extend({},a.fn.smoothScroll.defaults,b||{}),d.scrollElement&&(i="position",d.scrollElement.css("position")=="static"&&d.scrollElement.css("position","relative")),f=c||a(d.scrollTarget)[i]()&&a(d.scrollTarget)[i]()[d.direction]||0),d=a.extend({link:null},d),j=d.direction=="left"?"scrollLeft":j,d.scrollElement?(e=d.scrollElement,h=e[j]()):e=a("html, body").firstScrollable(),k[j]=f+h+d.offset,d.beforeScroll.call(e,d),g=d.speed,g==="auto"&&(g=k[j]||e.scrollTop(),g=g/d.autoCoefficent),l={duration:g,easing:d.easing,complete:function(){d.afterScroll.call(d.link,d)}},d.step&&(l.step=d.step),e.length?e.stop().animate(k,l):d.afterScroll.call(d.link,d)},a.smoothScroll.version=b,a.smoothScroll.filterPath=function(a){return a.replace(/^\//,"").replace(/(index|default).[a-zA-Z]{3,4}$/,"").replace(/\/$/,"")},a.fn.smoothScroll.defaults=c})(jQuery);